----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:57:10 12/03/2009 
-- Design Name: 
-- Module Name:    usb_module_phase2b - arch
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;
use work.sercon_types.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity usb_module_phase2b is
    Port ( 
			clk : in  STD_LOGIC;
         reset : in  STD_LOGIC;
			
			--
			-- Usb interface
			--
			sx2_ifclk			: out		std_logic;
			sx2_int				: in		std_logic;
			sx2_ready			: in		std_logic;
			sx2_reset			: out		std_logic;
			sx2_sloe				: out		std_logic;
			sx2_slrd				: out		std_logic;
			sx2_slwr				: out		std_logic;
			sx2_pkt_end			: out		std_logic;
			sx2_fifo_address	: out		std_logic_vector(2 downto 0);
			sx2_flag_a			: in		std_logic;
			sx2_flag_b			: in		std_logic;
			sx2_flag_c			: in		std_logic;
			sx2_wakeup			: out		std_logic;
			sx2_n_cs				: out		std_logic;
			sx2_fifo_data		: inout	std_logic_vector(15 downto 0);
			usb_nc				: in		std_logic;
			
			--
			-- User Register Signals
			--
			int_sysclk 				: out std_logic;
			int_logic_reset		: out std_logic;
			sx2_ControlReg			: out std_logic_vector(31 downto 0); -- 00
			sx2_SP1Wide				: out std_logic_vector(31 downto 0); -- 01 
			sx2_MTH_Timer			: out std_logic_vector(31 downto 0); -- 02
			
			sx2_HoldPosMax			: out std_logic_vector(31 downto 0); -- 03
			sx2_PWMSetup			: out std_logic_vector(31 downto 0);
			sx2_WDTValue			: out std_logic_vector(31 downto 0);
			sx2_ISISDelay1			: out std_logic_vector(31 downto 0);
			sx2_ISISDelay2			: out std_logic_vector(31 downto 0);
			sx2_ErrorCorrection	: out std_logic_vector(31 downto 0); -- Includes ECCountMax ECThreshold and DefaultOffset
			sx2_CapSettleTime		: out std_logic_vector(31 downto 0);
			sx2_CapWaitTime		: out std_logic_vector(31 downto 0);
			sx2_QCSetup				: out std_logic_vector(31 downto 0); -- Includes QC InitialPos and QCIndexOffset
			sx2_DeadTime			: out std_logic_vector(31 downto 0);
			sx2_KickBackTime		: out std_logic_vector(31 downto 0);	
			sx2_DropLimit			: out std_logic_vector(31 downto 0);
			sx2_LegalSpillDelay	: out std_logic_vector(31 downto 0);
			sx2_ResetRegister		: out std_logic_vector(31 downto 0);
			
			sx2_StatusRegister	: in  std_logic_vector(31 downto 0);
			sx2_ActuationMinMax	: in  std_logic_vector(31 downto 0);
			sx2_ActuationCount	: in  std_logic_vector(31 downto 0);
			sx2_ActuationError	: in  std_logic_vector(31 downto 0);
			sx2_ActuationSP		: in  std_logic_vector(31 downto 0);
			
			sx2_ActuationSP1Time : in  std_logic_vector(31 downto 0);
			sx2_ActuationMinTime	: in  std_logic_vector(31 downto 0);
			sx2_ActuationTime		: in  std_logic_vector(31 downto 0);
			
			sx2_NotifyRegister	: in  std_logic_vector(31 downto 0);
			
			-- BPS stuff
			sx2_Sp1MaxTime			: out  std_logic_vector(31 downto 0);
			sx2_Sp1MinTime			: out  std_logic_vector(31 downto 0);
			sx2_MinPosMaxTime		: out  std_logic_vector(31 downto 0);
			sx2_MinPosMinTime		: out  std_logic_vector(31 downto 0);
			sx2_MinPosMaxValue	: out  std_logic_vector(31 downto 0);
			sx2_MinPosMinValue	: out  std_logic_vector(31 downto 0);
			sx2_ActMaxTime			: out  std_logic_vector(31 downto 0);
			sx2_ActMinTime			: out  std_logic_vector(31 downto 0);
			
			sx2_BPSErrors			: in  std_logic_vector(31 downto 0);
			sx2_BPSErrorData		: in  std_logic_vector(31 downto 0);
			
			-- PC Check
			sx2_PCCounter			: out  std_logic_vector(31 downto 0);
			
			-- Further BPS
			sx2_ActuationSp1MaxTime			: in std_logic_vector(31 downto 0);
			sx2_ActuationSp1MinTime			: in std_logic_vector(31 downto 0);		
			sx2_ActuationMinPosMaxTime		: in std_logic_vector(31 downto 0);		
			sx2_ActuationMinPosMinTime		: in std_logic_vector(31 downto 0);		
			sx2_ActuationMinPosMaxValue	: in std_logic_vector(31 downto 0);		
			sx2_ActuationMinPosMinValue	: in std_logic_vector(31 downto 0);		
			sx2_ActuationActMaxTime			: in std_logic_vector(31 downto 0);		
			sx2_ActuationActMinTime			: in std_logic_vector(31 downto 0);

			-- Additional registers for setting gains via SPI
			sx2_ChannelGains 				: out std_logic_vector(31 downto 0);
			--sx2_ChAGain 			: out std_logic_vector(31 downto 0);
			--sx2_ChBGain 			: out std_logic_vector(31 downto 0);
			--sx2_IndxGain 			: out std_logic_vector(31 downto 0);
			
			-- These form part of the actuation data
			sx2_ActuationChAOutput 	: in std_logic_vector(31 downto 0);
			sx2_ActuationChBOutput	: in std_logic_vector(31 downto 0);
			sx2_ActuationIndxOutput	: in std_logic_vector(31 downto 0);
			
			sx2_Engineering			: out std_logic_vector(31 downto 0);
			
			-- Increases PWM on capture to reduce liklihood of sticking
			sx2_CaptureBoost			: out std_logic_vector(31 downto 0);
			
			-- Another Actuation Data Register
			sx2_Velocity				: in  std_logic_vector(31 downto 0)		
			
			);
					
end usb_module_phase2b;

architecture arch of usb_module_phase2b is

			-- USB Registers		
			signal sx2_ControlReg_Int  		: std_logic_vector(31 downto 0);
			signal sx2_SP1Wide_Int				: std_logic_vector(31 downto 0);
			signal sx2_MTH_Timer_Int			: std_logic_vector(31 downto 0);
			signal sx2_HoldPosMax_Int			: std_logic_vector(31 downto 0);
			signal sx2_PWMSetup_Int				: std_logic_vector(31 downto 0);
			signal sx2_WDTValue_Int				: std_logic_vector(31 downto 0);
			signal sx2_ISISDelay1_Int			: std_logic_vector(31 downto 0);
			signal sx2_ISISDelay2_Int			: std_logic_vector(31 downto 0);
			signal sx2_ErrorCorrection_Int	: std_logic_vector(31 downto 0); -- Includes ECCountMax ECThreshold and DefaultOffset
			signal sx2_CapSettleTime_Int		: std_logic_vector(31 downto 0);
			signal sx2_CapWaitTime_Int			: std_logic_vector(31 downto 0);
			signal sx2_QCSetup_Int				: std_logic_vector(31 downto 0); -- Includes QC InitialPos and QCIndexOffset
			signal sx2_DeadTime_Int				: std_logic_vector(31 downto 0);
			signal sx2_KickBackTime_Int		: std_logic_vector(31 downto 0);	
			signal sx2_DropLimit_Int			: std_logic_vector(31 downto 0);
			signal sx2_LegalSpill_Int			: std_logic_vector(31 downto 0);
			signal sx2_ResetRegister_Int		: std_logic_vector(31 downto 0);
			
			signal sx2_StatusRegister_Int		: std_logic_vector(31 downto 0);
			signal sx2_ActuationMinMax_Int	: std_logic_vector(31 downto 0);
			signal sx2_ActuationCount_Int		: std_logic_vector(31 downto 0);
			signal sx2_ActuationError_Int		: std_logic_vector(31 downto 0);
			signal sx2_ActuationSP_Int			: std_logic_vector(31 downto 0);		
			signal sx2_ActuationSP1Time_Int 	: std_logic_vector(31 downto 0);
			signal sx2_ActuationMinTime_Int	: std_logic_vector(31 downto 0);
			signal sx2_ActuationTime_Int		: std_logic_vector(31 downto 0);
			signal sx2_NotifyRegister_Int		: std_logic_vector(31 downto 0);	
			
			-- BPS
			signal sx2_Sp1MaxTime_Int		: std_logic_vector(31 downto 0);
			signal sx2_Sp1MinTime_Int		: std_logic_vector(31 downto 0);
			signal sx2_MinPosMaxTime_Int	: std_logic_vector(31 downto 0);
			signal sx2_MinPosMinTime_Int	: std_logic_vector(31 downto 0);
			signal sx2_MinPosMaxValue_Int	: std_logic_vector(31 downto 0);
			signal sx2_MinPosMinValue_Int	: std_logic_vector(31 downto 0);
			signal sx2_ActMaxTime_Int		: std_logic_vector(31 downto 0);
			signal sx2_ActMinTime_Int		: std_logic_vector(31 downto 0);
			
			signal sx2_BPSErrors_Int		: std_logic_vector(31 downto 0);
			signal sx2_BPSErrorData_Int	: std_logic_vector(31 downto 0);
			
			-- PC Check
			signal sx2_PCCounter_Int		: std_logic_vector(31 downto 0);
			
			-- BPS Actuation Data
			signal sx2_ActSp1MaxTime_Int		: std_logic_vector(31 downto 0);
			signal sx2_ActSp1MinTime_Int		: std_logic_vector(31 downto 0);		
			signal sx2_ActMinPosMaxTime_Int	: std_logic_vector(31 downto 0);		
			signal sx2_ActMinPosMinTime_Int	: std_logic_vector(31 downto 0);		
			signal sx2_ActMinPosMaxValue_Int	: std_logic_vector(31 downto 0);		
			signal sx2_ActMinPosMinValue_Int	: std_logic_vector(31 downto 0);		
			signal sx2_ActActMaxTime_Int		: std_logic_vector(31 downto 0);		
			signal sx2_ActActMinTime_Int		: std_logic_vector(31 downto 0);

			-- Additional registers for setting gains via SPI
			signal   sx2_ChannelGains_Int		: std_logic_vector(31 downto 0);
			--signal sx2_ChAGain_Int			: std_logic_vector(31 downto 0);
			--signal sx2_ChBGain_Int 			: std_logic_vector(31 downto 0);
			--signal sx2_IndxGain_Int 		: std_logic_vector(31 downto 0);
			
			-- These form part of the actuation data
			signal sx2_ActChAOutput_Int 	: std_logic_vector(31 downto 0);
			signal sx2_ActChBOutput_Int	: std_logic_vector(31 downto 0);
			signal sx2_ActIndxOutput_Int	: std_logic_vector(31 downto 0);
			
			signal sx2_Engineering_Int		: std_logic_vector(31 downto 0);
			
			-- Increases PWM on capture to reduce liklihood of sticking
			signal sx2_CaptureBoost_Int	: std_logic_vector(31 downto 0);
			
			-- Velocity Output - Actuation Data
			signal sx2_Velocity_Int			: std_logic_vector(31 downto 0);
			
			-- USB Signals
			-- Need a new bus connection for each register
			-- Ctrl Register
			signal int_config_ctrl	: sercon_ctrl;
			
			-- Other Registers
			signal int_config_bus_0 : sercon_bus;		
			--REGISTER: ControlReg							-- sx2_ControlReg_Int
			
			signal int_config_bus_1 : sercon_bus;
			--REGISTER: SP1Wide								-- sx2_SP1Wide_Int
			
			signal int_config_bus_2 : sercon_bus;		
			--REGISTER: MTH_Timer							-- sx2_MTH_Timer_Int
			
			signal int_config_bus_3 : sercon_bus;		
			--REGISTER: HoldPosMax							-- sx2_HoldPosMax_Int
			
			signal int_config_bus_4 : sercon_bus;		
			--REGISTER: PWMSetup								-- sx2_PWMSetup_Int
			
			signal int_config_bus_5 : sercon_bus;		
			--REGISTER: WDTValue								-- sx2_WDTValue_Int
			
			signal int_config_bus_6 : sercon_bus;		
			--REGISTER: ISISDelay1							-- sx2_ISISDelay1_Int
			
			signal int_config_bus_7 : sercon_bus;		
			--REGISTER: ISISDelay2							-- sx2_ISISDelay2_Int
			
			signal int_config_bus_8 : sercon_bus;		
			--REGISTER: ErrorCorrection					-- sx2_ErrorCorrection_Int
			
			signal int_config_bus_9 : sercon_bus;		
			--REGISTER: CapSettleTime						-- sx2_CapSettleTime_Int
			
			signal int_config_bus_10 : sercon_bus;		
			--REGISTER: CapWaitTime							-- sx2_CapWaitTime_Int
			
			signal int_config_bus_11 : sercon_bus;		
			--REGISTER: QCSetup								-- sx2_QCSetup_Int
			
			signal int_config_bus_12 : sercon_bus;		
			--REGISTER: DeadTime								-- sx2_DeadTime_Int
			
			signal int_config_bus_13 : sercon_bus;		
			--REGISTER: KickBackTime						-- sx2_KickBackTime_Int
			
			signal int_config_bus_14 : sercon_bus;
			--REGISTER: DropLimit							-- sx2_DropLimit_Int
			
			signal int_config_bus_15 : sercon_bus;
			--REGISTER: LegalSpill							-- sx2_LegalSpill_Int
			
			signal int_config_bus_16 : sercon_bus;
			--REGISTER: ResetRegister						-- sx2_ResetRegister_Int
			
			
			-- ****************************
			-- STATUS REGISTERS (READ ONLY)
			-- ****************************
			
			signal int_config_bus_17 : sercon_bus;
			--REGISTER: StatusRegister						-- sx2_StatusRegister_Int
			
			--*** REMOVED ***
			--signal int_config_bus_18 : sercon_bus;
			--REGISTER: CurrentPosition					-- sx2_CurrentPosition_Int
			
			signal int_config_bus_19 : sercon_bus;
			--REGISTER: ActuationMinMax					-- sx2_ActuationMinMax_Int
			
			signal int_config_bus_20 : sercon_bus;
			--REGISTER: ActuationCount						-- sx2_ActuationCount_Int
			
			signal int_config_bus_21 : sercon_bus;
			--REGISTER: ActuationError						-- sx2_ActuationError_Int
			
			signal int_config_bus_22 : sercon_bus;
			--REGISTER: ActuationSetPoints				-- sx2_ActuationSetPoints_Int
			
			signal int_config_bus_23 : sercon_bus;
			--REGISTER: ActuationSP1Time					-- sx2_ActuationSP1Time_Int
			
			signal int_config_bus_24 : sercon_bus;
			--REGISTER: ActuationMinTime					-- sx2_ActuationMinTime_Int
			
			signal int_config_bus_25 : sercon_bus;
			--REGISTER: ActuationTime						-- sx2_ActuationTime_Int
						
			signal int_config_bus_26 : sercon_bus;
			--REGISTER: Notification						-- sx2_NotifyRegister_Int
			
			-- ****************************
			-- BPS REGISTERS 
			-- ****************************
			
			signal int_config_bus_27 : sercon_bus;
			--REGISTER: SP1MaxTime							-- sx2_Sp1MaxTime_Int
			
			signal int_config_bus_28 : sercon_bus;
			--REGISTER: SP1MinTime							-- sx2_Sp1MinTime_Int
			
			signal int_config_bus_29 : sercon_bus;
			--REGISTER: MinPosMaxTime						-- sx2_MinPosMaxTime_Int
			
			signal int_config_bus_30 : sercon_bus;
			--REGISTER: MonPosMinTime						-- sx2_MinPosMinTime_Int				
			
			signal int_config_bus_31 : sercon_bus;
			--REGISTER: MinPosMaxValue						-- sx2_MinPosMaxValue_Int
			
			signal int_config_bus_32 : sercon_bus;
			--REGISTER: MinPosMinValue						-- sx2_MinPosMinValue_Int	
			
			signal int_config_bus_33 : sercon_bus;
			--REGISTER: ActMaxTime							-- sx2_ActMaxTime_Int

			signal int_config_bus_34 : sercon_bus;		
			--REGISTER: ActMinTime							-- sx2_ActMinTime_Int		
			
			signal int_config_bus_35 : sercon_bus;		
			--REGISTER: BPS_Errors							-- sx2_BPSErrors_Int	
			
			signal int_config_bus_36 : sercon_bus;
			--REGISTER: BPS_ErrorData						-- sx2_BPSErrorData_Int
			
			-- ****************************
			-- PC Watchdog REGISTER
			-- ****************************
			
			signal int_config_bus_37 : sercon_bus;
			--REGISTER: PCCounter							-- sx2_PCCounter_Int
			
			-- *******************************
			-- BPS Actuation Data REGISTERS
			-- *******************************
			
			signal int_config_bus_38 : sercon_bus;		-- sx2_ActSp1MaxTime_Int
			-- REGISTER: ActSp1MaxTime
			
			signal int_config_bus_39 : sercon_bus;		-- sx2_ActSp1MinTime_Int
			-- REGISTER: ActSp1MinTime
			
			signal int_config_bus_40 : sercon_bus;		-- sx2_ActMinPosMaxTime_Int
			-- REGISTER: ActMinPosMaxTime
			
			signal int_config_bus_41 : sercon_bus;		-- sx2_ActMinPosMinTime_Int
			-- REGISTER: ActMinPosMinTime
			
			signal int_config_bus_42 : sercon_bus;		-- sx2_ActMinPosMaxValue_Int
			-- REGISTER: ActMinPosMaxValue
			
			signal int_config_bus_43 : sercon_bus;		-- sx2_ActMinPosMinValue_Int
			-- REGISTER: ActMinPosMinValue
			
			signal int_config_bus_44 : sercon_bus;		-- sx2_ActActMaxTime_Int
			-- REGISTER: ActActMaxTime
			
			signal int_config_bus_45 : sercon_bus;		-- sx2_ActActMinTime_Int
			-- REGISTER: ActActMinTime
			
			-- *******************************
			-- setting gains via SPI
			-- *******************************
			
			signal int_config_bus_46 : sercon_bus;		-- sx2_ChannelGains_Int
			-- REGISTER: ChannelGains
			
			--signal int_config_bus_46 : sercon_bus;		-- sx2_ChAGain_Int
			-- REGISTER: ChAGain 
			
			--signal int_config_bus_47 : sercon_bus;		-- sx2_ChBGain_Int
			-- REGISTER: ChBGain
			
			--signal int_config_bus_48 : sercon_bus;		-- sx2_IndxGain_Int
			-- REGISTER: IndxGain
			
			-- *******************************
			-- Further Actuation data
			-- *******************************
			
			signal int_config_bus_49 : sercon_bus;		-- sx2_ActChAOutput_Int
			-- REGISTER: ActChAOutput 
			
			signal int_config_bus_50 : sercon_bus;		-- sx2_ActChBOutput_Int
			-- REGISTER: ActChBOutput 
			
			signal int_config_bus_51 : sercon_bus;		-- sx2_ActIndxOutput_Int
			-- REGISTER: ActIndxOutput
			
			signal int_config_bus_52 : sercon_bus;		-- sx2_Engineering_Int
			-- REGISTER: Engineering
			
			signal int_config_bus_53 : sercon_bus;		-- sx2_CaptureBoost	
			-- REGISTER: Capture Boost
			
			signal int_config_bus_54 : sercon_bus;		-- sx2 Velocity
			-- REGISTER: Velocity
			
			-- *******************************
			-- Termination
			-- *******************************
			
			signal int_config_bus_dest : sercon_bus;
			
begin

			-- Register Mapping To OUTPUTS			
			sx2_ControlReg 			<= sx2_ControlReg_Int;
			sx2_SP1Wide 				<= sx2_SP1Wide_Int;
			sx2_MTH_Timer 				<= sx2_MTH_Timer_Int;
			sx2_HoldPosMax 			<= sx2_HoldPosMax_Int;
			sx2_PWMSetup				<= sx2_PWMSetup_Int;	
			sx2_WDTValue				<= sx2_WDTValue_Int;	
			sx2_ISISDelay1				<= sx2_ISISDelay1_Int;
			sx2_ISISDelay2				<= sx2_ISISDelay2_Int;
			sx2_ErrorCorrection		<= sx2_ErrorCorrection_Int;
			sx2_CapSettleTime			<= sx2_CapSettleTime_Int;
			sx2_CapWaitTime			<= sx2_CapWaitTime_Int;	
			sx2_QCSetup					<=	sx2_QCSetup_Int;	
			sx2_DeadTime				<=	sx2_DeadTime_Int;
			sx2_KickBackTime			<= sx2_KickBackTime_Int;
			sx2_DropLimit				<=	sx2_DropLimit_Int;		
			sx2_LegalSpillDelay		<= sx2_LegalSpill_Int;
			sx2_ResetRegister			<= sx2_ResetRegister_Int;
			
			--Register Mapping to Input
			sx2_StatusRegister_Int		<= sx2_StatusRegister;
			-- ** REGISTER REMOVED **
			--sx2_CurrentPosition_Int 	<= sx2_CurrentPosition;
			sx2_ActuationMinMax_Int		<= sx2_ActuationMinMax;
			sx2_ActuationCount_Int		<= sx2_ActuationCount;
			sx2_ActuationError_Int		<= sx2_ActuationError;
			sx2_ActuationSP_Int			<= sx2_ActuationSP;
			sx2_NotifyRegister_Int		<= Sx2_NotifyRegister;
			sx2_ActuationSP1Time_Int 	<= sx2_ActuationSP1Time;	
			sx2_ActuationMinTime_Int	<= sx2_ActuationMinTime;
			sx2_ActuationTime_Int		<= sx2_ActuationTime;	
			
			--Register Mapping to BPS (OUTPUTS)
			sx2_Sp1MaxTime			<= sx2_Sp1MaxTime_Int;
			sx2_Sp1MinTime			<= sx2_Sp1MinTime_Int;		
			sx2_MinPosMaxTime		<= sx2_MinPosMaxTime_Int;	
			sx2_MinPosMinTime		<= sx2_MinPosMinTime_Int;	
			sx2_MinPosMaxValue	<= sx2_MinPosMaxValue_Int;	
			sx2_MinPosMinValue	<= sx2_MinPosMinValue_Int;
			sx2_ActMaxTime			<= sx2_ActMaxTime_Int;	
			sx2_ActMinTime			<= sx2_ActMinTime_Int;
			
			--Register Mapping to BPS (INPUTS)
			sx2_BPSErrors_Int			<= sx2_BPSErrors;	
			sx2_BPSErrorData_Int		<= sx2_BPSErrorData;
			
			-- PC Check (OUTPUT)
			sx2_PCCounter			<= sx2_PCCounter_Int;		

			-- BPS Actuation Data (INPUTS)
			sx2_ActSp1MaxTime_Int		<=	sx2_ActuationSp1MaxTime;
			sx2_ActSp1MinTime_Int		<= sx2_ActuationSp1MinTime;
			sx2_ActMinPosMaxTime_Int	<=	sx2_ActuationMinPosMaxTime;
			sx2_ActMinPosMinTime_Int	<=	sx2_ActuationMinPosMinTime;	
			sx2_ActMinPosMaxValue_Int	<= sx2_ActuationMinPosMaxValue;
			sx2_ActMinPosMinValue_Int	<= sx2_ActuationMinPosMinValue;
			sx2_ActActMaxTime_Int		<=	sx2_ActuationActMaxTime;
			sx2_ActActMinTime_Int		<= sx2_ActuationActMinTime;
			
			-- Additional registers for setting gains via SPI (OUTPUTS)
			sx2_ChannelGains		<= sx2_ChannelGains_Int;	
			--sx2_ChAGain		<= sx2_ChAGain_Int;		
			--sx2_ChBGain		<= sx2_ChBGain_Int;			
			--sx2_IndxGain	<= sx2_IndxGain_Int; 		
			
			-- These form part of the actuation data (INPUTS)
			sx2_ActChAOutput_Int			<= sx2_ActuationChAOutput; 	
			sx2_ActChBOutput_Int			<= sx2_ActuationChBOutput;	
			sx2_ActIndxOutput_Int		<= sx2_ActuationIndxOutput;

			-- Miscellaneous registers
			sx2_Engineering 	<= sx2_Engineering_Int;
			sx2_CaptureBoost 	<= sx2_CaptureBoost_Int;
			
			sx2_Velocity_Int	<= sx2_Velocity;

			sx2_ui: entity work.sx2_ui(v0)			
			port map(
					rstin					=> reset,
					clkin					=> clk,
					--
					--
					sysclk				=> int_sysclk,
					logic_reset			=> int_logic_reset,
					--
					-- Usb interface
					--
					sx2_ifclk			=> sx2_ifclk,
					sx2_int				=> sx2_int,
					sx2_ready			=> sx2_ready,
					sx2_reset			=> sx2_reset,
					sx2_sloe				=> sx2_sloe,
					sx2_slrd				=> sx2_slrd,
					sx2_slwr				=> sx2_slwr,
					sx2_pkt_end			=> sx2_pkt_end,
					sx2_fifo_address	=> sx2_fifo_address,
					sx2_flag_a			=> sx2_flag_a,
					sx2_flag_b			=> sx2_flag_b,
					sx2_flag_c			=> sx2_flag_c,
					sx2_wakeup			=> sx2_wakeup,
					sx2_n_cs				=> sx2_n_cs,
					sx2_fifo_data		=> sx2_fifo_data,
					usb_nc				=> usb_nc,
					--
					--
					flush_sx2_buffers	=> open,
					--
					-- User configuration interface
					--
					config_control		=> int_config_ctrl,
					config_src			=> int_config_bus_0,
					config_dest			=> int_config_bus_dest,
					--
					-- Data pipe for block transfers into the design (from the pc)
					--
					wren					=> open,
					full					=> '0',
					data_from_pc		=> open,
					--
					-- Data pipe for block transfers out of the design (to the pc)
					--
					rden					=> open,
					empty					=> '1',
					data_to_pc			=> (others => '0')
				);
	
			-- ////////////////////////////////
			--
			--       Register CONNECTIONS
			--
			-- ///////////////////////////////
	
			-- sx2_ControlReg_Int -- Register 0
			ControlReg: entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_0,
				sbus_out	=> int_config_bus_1,
				--
				pdout		=> sx2_ControlReg_Int,
				pdin		=> sx2_ControlReg_Int
				);	
		
		
			-- sx2_SP1Wide_Int -- Register 1
			SP1Wide: entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_1,
				sbus_out	=> int_config_bus_2,
				--
				pdout		=> sx2_SP1Wide_Int,
				pdin		=> sx2_SP1Wide_Int
				);
				
			-- sx2_MTH_Timer_Int -- Register 2
			MTH_Timer: entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_2,
				sbus_out	=> int_config_bus_3,
				--
				pdout		=> sx2_MTH_Timer_Int,
				pdin		=> sx2_MTH_Timer_Int
				);
				
			-- sx2_HoldPosMax_Int -- Register 3
			HoldPosMax: entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_3,
				sbus_out	=> int_config_bus_4,
				--
				pdout		=> sx2_HoldPosMax_Int,
				pdin		=> sx2_HoldPosMax_Int
				);
				
			-- sx2_PWMSetup_Int	-- Register 4
			PWMSetup: entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_4,
				sbus_out	=> int_config_bus_5,
				--
				pdout		=> sx2_PWMSetup_Int,
				pdin		=> sx2_PWMSetup_Int
				);
				
			-- sx2_WDTValue_Int -- Register 5
			WDTValue: entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_5,
				sbus_out	=> int_config_bus_6,
				--
				pdout		=> sx2_WDTValue_Int,
				pdin		=> sx2_WDTValue_Int
				);
			
			-- sx2_ISISDelay1_Int -- Register 6			
			ISISDelay1: entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_6,
				sbus_out	=> int_config_bus_7,
				--
				pdout		=> sx2_ISISDelay1_Int,
				pdin		=> sx2_ISISDelay1_Int
				);
				
			-- sx2_ISISDelay2_Int -- Register 7	
			ISISDelay2: entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_7,
				sbus_out	=> int_config_bus_8,
				--
				pdout		=> sx2_ISISDelay2_Int,
				pdin		=> sx2_ISISDelay2_Int
				);
				
			-- sx2_ErrorCorrection_Int	-- Register 8	
			ErrorCorrection: entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_8,
				sbus_out	=> int_config_bus_9,
				--
				pdout		=> sx2_ErrorCorrection_Int,
				pdin		=> sx2_ErrorCorrection_Int
				);
				
			-- sx2_CapSettleTime_Int -- Register 9	
			CapSettleTime: entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_9,
				sbus_out	=> int_config_bus_10,
				--
				pdout		=> sx2_CapSettleTime_Int,
				pdin		=> sx2_CapSettleTime_Int
				);
			
			-- sx2_CapWaitTime_Int -- Register 10	
			CapWaitTime: entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_10,
				sbus_out	=> int_config_bus_11,
				--
				pdout		=> sx2_CapWaitTime_Int,
				pdin		=> sx2_CapWaitTime_Int
				);
				
			-- sx2_QCSetup_Int -- Register 11
			QCSetup: entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_11,
				sbus_out	=> int_config_bus_12,
				--
				pdout		=> sx2_QCSetup_Int,
				pdin		=> sx2_QCSetup_Int
				);
				
			-- sx2_DeadTime_Int -- Register 12 
			DeadTime: entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_12,
				sbus_out	=> int_config_bus_13,
				--
				pdout		=> sx2_DeadTime_Int,
				pdin		=> sx2_DeadTime_Int
				);

			-- sx2_KickBackTime_Int -- Register 13
			KickBackTime: entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_13,
				sbus_out	=> int_config_bus_14,
				--
				pdout		=> sx2_KickBackTime_Int,
				pdin		=> sx2_KickBackTime_Int
				);
				
			-- sx2_DropLimit_Int -- Register 14
			DropLimit:entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_14,
				sbus_out	=> int_config_bus_15,
				--
				pdout		=> sx2_DropLimit_Int,
				pdin		=> sx2_DropLimit_Int
				);
				
			-- sx2_LegalSpill_Int -- Register 15
			LegalSpill:entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_15,
				sbus_out	=> int_config_bus_16,
				--
				pdout		=> sx2_LegalSpill_Int,
				pdin		=> sx2_LegalSpill_Int
				);
				
			-- sx2_ResetRegister_Int - Register 16
			ResetRegister:entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_16,
				sbus_out	=> int_config_bus_17,
				--
				pdout		=> sx2_ResetRegister_Int,
				pdin		=> sx2_ResetRegister_Int
				);
			
			--  ****************
			--  STATUS REGISTERS
			--  ****************		
				-- sx2_StatusRegister_Int -- Register 17
			StatusRegister: entity work.sercon_stat(v0)
			generic map
				(
				bit_width => sercon_bit_width
				)
			port map(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_17,
				sbus_out	=> int_config_bus_19,
				--
				-- Parallel data input
				--
				pdin		=> sx2_StatusRegister_Int
				);
			

			-- REMOVED LATER
--			-- sx2_CurrentPosition_Int	-- Register 18
--			CurrentPosition: entity work.sercon_stat(v0)
--			generic map
--				(
--				bit_width => sercon_bit_width
--				)
--			port map(
--				ctrl		=> int_config_ctrl,
--				--
--				sbus_in	=> int_config_bus_18,
--				sbus_out	=> int_config_bus_19,
--				--
--				-- Parallel data input
--				--
--				pdin		=> sx2_CurrentPosition_Int
--				
--				);

			-- sx2_ActuationMinMax_Int -- Register 19
			ActuationMinMax:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_19,
				sbus_out	=> int_config_bus_20,
				--
				-- Parallel data input
				--
				pdin		=> sx2_ActuationMinMax_Int

				);
			
			-- sx2_ActuationCount_Int -- Register 20
			ActuationCount:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_20,
				sbus_out	=> int_config_bus_21,
				--
				pdin		=> sx2_ActuationCount_Int
				);	
				
			-- sx2_ActuationError_Int -- Register 21
			ActuationError:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_21,
				sbus_out	=> int_config_bus_22,
				--
				pdin		=> sx2_ActuationError_Int	
				);	
				
			-- sx2_ActuationSetPoints_Int -- Register 22
			ActuationSP:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_22,
				sbus_out	=> int_config_bus_23,
				--
				pdin		=> sx2_ActuationSP_Int
				);	

		
			-- sx2_ActuationSP1Time_Int -- Register 23
			ActuationSP1Time:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_23,
				sbus_out	=> int_config_bus_24,
				--
				pdin		=> sx2_ActuationSP1Time_Int
				);	
				
			-- sx2_ActuationMinTime_Int -- Register 24
			ActuationMinTime:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_24,
				sbus_out	=> int_config_bus_25,
				--
				pdin		=> sx2_ActuationMinTime_Int
				);	

			-- sx2_ActuationTime_Int -- Register 25
			ActuationTime:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_25,
				sbus_out	=> int_config_bus_26,
				--
				pdin		=> sx2_ActuationTime_Int
				);	
				
			-- sx2_NotifyRegister_Int -- Register 26
			Notification:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_26,
				sbus_out	=> int_config_bus_27,
				--
				pdin		=> sx2_NotifyRegister_Int
				);
				
			-- BPS Registers
			
			-- sx2_Sp1MaxTime_Int -- Register 27
			Sp1MaxTime:entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_27,
				sbus_out	=> int_config_bus_28,
				--
				pdout		=> sx2_Sp1MaxTime_Int,
				pdin		=> sx2_Sp1MaxTime_Int
				);
				
			-- sx2_Sp1MinTime_Int -- Register 28
			Sp1MinTime:entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_28,
				sbus_out	=> int_config_bus_29,
				--
				pdout		=> sx2_Sp1MinTime_Int,
				pdin		=> sx2_Sp1MinTime_Int
				);
				
			-- sx2_MinPosMaxTime_Int -- Register 29
			MinPosMaxTime:entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_29,
				sbus_out	=> int_config_bus_30,
				--
				pdout		=> sx2_MinPosMaxTime_Int,
				pdin		=> sx2_MinPosMaxTime_Int
				);
				
			-- sx2_MinPosMinTime_Int -- Register 30
			MinPosMinTime:entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_30,
				sbus_out	=> int_config_bus_31,
				--
				pdout		=> sx2_MinPosMinTime_Int,
				pdin		=> sx2_MinPosMinTime_Int
				);
				
			-- sx2_MinPosMaxValue_Int -- Register 31
			MinPosMaxValue:entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_31,
				sbus_out	=> int_config_bus_32,
				--
				pdout		=> sx2_MinPosMaxValue_Int,
				pdin		=> sx2_MinPosMaxValue_Int
				);
				
			-- sx2_MinPosMinValue_Int -- Register 32
			MinPosMinValue:entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_32,
				sbus_out	=> int_config_bus_33,
				--
				pdout		=> sx2_MinPosMinValue_Int,
				pdin		=> sx2_MinPosMinValue_Int
				);
				
			-- sx2_ActMaxTime_Int -- Register 33
			ActMaxTime:entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_33,
				sbus_out	=> int_config_bus_34,
				--
				pdout		=> sx2_ActMaxTime_Int,
				pdin		=> sx2_ActMaxTime_Int
				);
				
			-- sx2_ActMinTime_Int -- Register 34
			ActMinTime:entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_34,
				sbus_out	=> int_config_bus_35,
				--
				pdout		=> sx2_ActMinTime_Int,
				pdin		=> sx2_ActMinTime_Int
				);
				
			-- sx2_BPSErrors_Int -- Register 35
			BPSErrors:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_35,
				sbus_out	=> int_config_bus_36,
				--
				pdin		=> sx2_BPSErrors_Int
				);
				
			-- sx2_BPSErrorData_Int -- Register 36
			BPSErrorData:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_36,
				sbus_out	=> int_config_bus_37,
				--
				pdin		=> sx2_BPSErrorData_Int
				);
				
				
			-- PC Check (Output)
			-- sx2_PCCounter_Int -- Register 37
			PCCounter:entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_37,
				sbus_out	=> int_config_bus_38,
				--
				pdout		=> sx2_PCCounter_Int,
				pdin		=> sx2_PCCounter_Int	
				);
				
			-- BPS Data Registers (Inputs) 
			-- sx2_ActSp1MaxTime_Int -- Register 38
			ActSp1MaxTime:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_38,
				sbus_out	=> int_config_bus_39,
				--
				pdin		=> sx2_ActSp1MaxTime_Int
				);
				
			-- sx2_ActSp1MinTime_Int -- Register 39
			ActSp1MinTime:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_39,
				sbus_out	=> int_config_bus_40,
				--
				pdin		=> sx2_ActSp1MinTime_Int
				);
				
			-- sx2_ActMinPosMaxTime_Int -- Register 40
			ActMinPosMaxTime:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_40,
				sbus_out	=> int_config_bus_41,
				--
				pdin		=> sx2_ActMinPosMaxTime_Int
				);
				
			-- sx2_ActMinPosMinTime_Int -- Register 41
			ActMinPosMinTime:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_41,
				sbus_out	=> int_config_bus_42,
				--
				pdin		=> sx2_ActMinPosMinTime_Int
				);	
				
			-- sx2_ActMinPosMaxValue_Int -- Register 42
			ActMinPosMaxValue:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_42,
				sbus_out	=> int_config_bus_43,
				--
				pdin		=> sx2_ActMinPosMaxValue_Int
				);		
				
			-- sx2_ActMinPosMinValue_Int -- Register 43
			ActMinPosMinValue:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_43,
				sbus_out	=> int_config_bus_44,
				--
				pdin		=> sx2_ActMinPosMinValue_Int
				);		
			
			-- sx2_ActActMaxTime_Int -- Register 44
			ActActMaxTime:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_44,
				sbus_out	=> int_config_bus_45,
				--
				pdin		=> sx2_ActActMaxTime_Int
				);					
				
			-- sx2_ActActMinTime_Int -- Register 45
			ActActMinTime:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_45,
				sbus_out	=> int_config_bus_46,
				--
				pdin		=> sx2_ActActMinTime_Int
				);			
				
			-- setting gains via SPI
			-- sx2_ChannelGains_Int -- Register 46
			ChannelGains:entity work.sercon_reg(v0)
			generic map
				(
				reset_value	=> 0,
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_46,
				sbus_out	=> int_config_bus_49,
				--
				pdout		=> sx2_ChannelGains_Int,
				pdin		=> sx2_ChannelGains_Int	
				);
				
--			-- setting gains via SPI
--			-- sx2_ChAGain_Int -- Register 46
--			ChAGain:entity work.sercon_reg(v0)
--			generic map
--				(
--				reset_value	=> 0,
--				bit_width	=> sercon_bit_width
--				)
--			port map
--				(
--				ctrl		=> int_config_ctrl,
--				--
--				sbus_in	=> int_config_bus_46,
--				sbus_out	=> int_config_bus_47,
--				--
--				pdout		=> sx2_ChAGain_Int,
--				pdin		=> sx2_ChAGain_Int	
--				);
--
--
--			-- sx2_ChBGain_Int -- Register 47
--			ChBGain:entity work.sercon_reg(v0)
--			generic map
--				(
--				reset_value	=> 0,
--				bit_width	=> sercon_bit_width
--				)
--			port map
--				(
--				ctrl		=> int_config_ctrl,
--				--
--				sbus_in	=> int_config_bus_47,
--				sbus_out	=> int_config_bus_48,
--				--
--				pdout		=> sx2_ChBGain_Int,
--				pdin		=> sx2_ChBGain_Int	
--				);
--				
--			-- sx2_IndxGain_Int -- Register 48
--			IndxGain:entity work.sercon_reg(v0)
--			generic map
--				(
--				reset_value	=> 0,
--				bit_width	=> sercon_bit_width
--				)
--			port map
--				(
--				ctrl		=> int_config_ctrl,
--				--
--				sbus_in	=> int_config_bus_48,
--				sbus_out	=> int_config_bus_49,
--				--
--				pdout		=> sx2_IndxGain_Int,
--				pdin		=> sx2_IndxGain_Int	
--				);
				
			-- Further Actuation data
			-- sx2_ActChAOutput_Int -- Register 49
			ActChAOutput:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_49,
				sbus_out	=> int_config_bus_50,
				--
				pdin		=> sx2_ActChAOutput_Int
				);	

			-- sx2_ActChBOutput_Int -- Register 50
			ActChBOutput:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_50,
				sbus_out	=> int_config_bus_51,
				--
				pdin		=> sx2_ActChBOutput_Int
				);		

			-- sx2_ActIndxOutput_Int -- Register 51
			ActIndxOutput:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_51,
				sbus_out	=> int_config_bus_52,
				--
				pdin		=> sx2_ActIndxOutput_Int
				);

			-- sx2_Engineering_Int -- Register 52
			Engineering:entity work.sercon_reg(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_52,
				sbus_out	=> int_config_bus_53,
				--
				pdout		=> sx2_Engineering_Int,
				pdin		=> sx2_Engineering_Int
				);		

				-- sx2_CaptureBoost_Int -- Register 53
			CaptureBoost:entity work.sercon_reg(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_53,
				sbus_out	=> int_config_bus_54,
				--
				pdout		=> sx2_CaptureBoost_Int,
				pdin		=> sx2_CaptureBoost_Int
				);	

			-- sx2_Velocity_Int -- Register 54
			-- Actuation Data!
			VelocityOutput:entity work.sercon_stat(v0)
			generic map
				(
				bit_width	=> sercon_bit_width
				)
			port map
				(
				ctrl		=> int_config_ctrl,
				--
				sbus_in	=> int_config_bus_54,
				sbus_out	=> int_config_bus_dest,
				--
				pdin		=> sx2_Velocity_Int
				);
				
				--
				
				
end arch;

