----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:28:30 10/21/2009 
-- Design Name: 
-- Module Name:    ConfigurationBlock - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ConfigurationBlock is

    Port (
			 --CB_I_CurrentState				: in std_logic_vector(3 downto 0);
			 --CB_O_CurrentState				: out std_logic_vector(3 downto 0);
					
			 CB_I_HoldPositionMax			: in std_logic_vector(4 downto 0);
			 CB_O_HoldPositionMax			: out std_logic_vector(4 downto 0);
			 
			 CB_I_MTH_TimerValue				: in std_logic_vector(27 downto 0);
			 CB_O_MTH_TimerValue				: out std_logic_vector(27 downto 0);
	 
			 CB_I_PWMCycleCountMax			: in std_logic_vector(7 downto 0);
			 CB_O_PWMCycleCountMax			: out std_logic_vector(7 downto 0);
			 CB_I_PWMDutyCycle				: in std_logic_vector(7 downto 0);
			 CB_O_PWMDutyCycle				: out std_logic_vector(7 downto 0);
			 CB_I_PWMTImer						: in std_logic_vector(7 downto 0);
			 CB_O_PWMTimer						: out std_logic_vector(7 downto 0);

			 CB_I_Position						: in std_logic_vector(8 downto 0);
			 CB_O_Position						: out std_logic_vector(8 downto 0);
			 
			 CB_I_QuadInitialPos				: in std_logic_vector (8 downto 0);
			 CB_O_QuadInitialPos				: out std_logic_vector (8 downto 0);
			 CB_I_QuadIndexOffset			: in std_logic_vector (8 downto 0);
			 CB_O_QuadIndexOffset			: out std_logic_vector (8 downto 0);
			 
			 CB_I_SetPoint1					: in std_logic_vector(8 downto 0);
			 CB_O_SetPoint1					: out std_logic_vector(8 downto 0);
			 CB_I_SetPoint2					: in std_logic_vector(8 downto 0);
			 CB_O_SetPoint2					: out std_logic_vector(8 downto 0);
			 
			 CB_I_WDTTimerValue				: in std_logic_vector(23 downto 0);
			 CB_O_WDTTimerValue				: out std_logic_vector(23 downto 0);
			 		 
			 CB_I_ISISDelay1					: in std_logic_vector(29 downto 0);
			 CB_O_ISISDelay1					: out std_logic_vector(29 downto 0);
			 CB_I_ISISDelay2					: in std_logic_vector(19 downto 0);
			 CB_O_ISISDelay2					: out std_logic_vector(19 downto 0);
			 
			 CB_I_LegalSpillDelay			: in std_logic_vector(19 downto 0);
			 CB_O_LegalSpillDelay			: out std_logic_vector(19 downto 0);
			 
			 CB_I_ECCountMax					: in std_logic_vector(7 downto 0);
			 CB_O_ECCountMax					: out std_logic_vector(7 downto 0);
			 CB_I_ECThreshold					: in std_logic_vector(7 downto 0);
			 CB_O_ECThreshold					: out std_logic_vector(7 downto 0);
			 CB_I_DefaultOffset				: in std_logic_vector(8 downto 0);
			 CB_O_DefaultOffset				: out std_logic_vector(8 downto 0);
			 
			 CB_I_SysInitOK					: in std_logic;
			 CB_O_SysInitOK					: out std_logic;
			 
			 CB_I_KeyEnableDeGlitch			: in std_logic;
			 CB_O_KeyEnableDeGlitch			: out std_logic;

			 CB_I_DeadTime						: in std_logic_vector(11 downto 0);
			 CB_O_DeadTime						: out std_logic_vector(11 downto 0);
			 
			 CB_I_DropLimit					: in std_logic_vector(8 downto 0);
			 CB_O_DropLimit					: out std_logic_vector(8 downto 0);
			 
			 CB_I_KickBackTime				: in std_logic_vector(17 downto 0);
			 CB_O_KickBackTime				: out std_logic_vector(17 downto 0);
			 
			 -- These need moving/copying to output block once USB is added
			 --CB_I_FrameRaisedLED				: in std_logic;
			 --CB_O_FrameRaisedLED				: out std_logic;
			 --CB_I_FrameLoweredLED			: in std_logic;
			 --CB_O_FrameLoweredLED			: out std_logic;
			 
			 CB_I_TargetFrameEnable			: in std_logic;
			 CB_O_TargetFrameEnable			: out std_logic;
			 
			 CB_I_ActuateCount				: in std_logic_vector(23 downto 0);
			 CB_O_ActuateCount				: out std_logic_vector(23 downto 0);
			 
			 CB_I_ActuateMinPos				: in std_logic_vector(8 downto 0);
			 CB_O_ActuateMinPos				: out std_logic_vector(8 downto 0);
			 		 
			 CB_I_CapActive					: in std_logic;
			 CB_O_CapActive					: out std_logic;
			 
			 CB_I_CapSettleTime				: in std_logic_vector(31 downto 0);
			 CB_O_CapSettleTime				: out std_logic_vector(31 downto 0);
			 
			 CB_I_CapWaitTime					: in std_logic_vector(31 downto 0);
			 CB_O_CapWaitTime					: out std_logic_vector(31 downto 0)
			 
			 );
			 
end ConfigurationBlock;

architecture arch of ConfigurationBlock is

begin 

	--CB_O_CurrentState	 <= CB_I_CurrentState;
	
	CB_O_HoldPositionMax <= CB_I_HoldPositionMax;
	CB_O_MTH_TimerValue 	<= CB_I_MTH_TimerValue;
	
	CB_O_PWMCycleCountMax <= CB_I_PWMCycleCountMax;
	CB_O_PWMDutyCycle 	<= CB_I_PWMDutyCycle;
	CB_O_PWMTimer 			<= CB_I_PWMTimer;
	
	CB_O_Position 			<= CB_I_Position;
	
	CB_O_QuadInitialPos 	<= CB_I_QuadInitialPos;
	CB_O_QuadIndexOffset <= CB_I_QuadIndexOffset;
	
	CB_O_SetPoint1 		<= CB_I_SetPoint1;
	CB_O_SetPoint2 		<= CB_I_SetPoint2;
	
	CB_O_WDTTimerValue 	<= CB_I_WDTTimerValue;
	
	CB_O_ISISDelay1 		<= CB_I_ISISDelay1;
	CB_O_ISISDelay2 		<= CB_I_ISISDelay2;
	CB_O_LegalSpillDelay <= CB_I_LegalSpillDelay;
	
	CB_O_ECCountMax 		<= CB_I_ECCountMax;
	CB_O_ECThreshold 		<= CB_I_ECThreshold;
	
	CB_O_SysInitOK 		<= CB_I_SysInitOK;
	
	CB_O_KeyEnableDeGlitch	<= CB_I_KeyEnableDeGlitch;
	
	--CB_O_FrameRaisedLED 	<= CB_I_FrameRaisedLED;
	--CB_O_FrameLoweredLED <= CB_I_FrameLoweredLED;
	
	CB_O_CapActive 		<= CB_I_CapActive;	
	CB_O_CapSettleTime 	<= CB_I_CapSettleTime;
	CB_O_CapWaitTime 		<= CB_I_CapWaitTime;
	
	CB_O_TargetFrameEnable		<= CB_I_TargetFrameEnable;
	
	CB_O_DeadTime			<= CB_I_DeadTime;
	CB_O_KickBackTime		<= CB_I_KickBackTime;

	CB_O_DropLimit			<= CB_I_DropLimit;					
	
	CB_O_ActuateCount <= CB_I_ActuateCount;	

	CB_O_DefaultOffset <= CB_I_DefaultOffset;
	
	CB_O_ActuateMinPos	<= CB_I_ActuateMinPos;
			 		 
			
end arch;

