----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    22:09:20 09/13/2012 
-- Design Name: 
-- Module Name:    min_width_mod - arch 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity min_width_mod is
    Port ( clk, en_tick : in  STD_LOGIC;
           sig_input : in  STD_LOGIC;
           sig_output : out  STD_LOGIC);
end min_width_mod;

architecture arch of min_width_mod is

	signal reg0_reg, reg0_next : std_logic := '0';
	signal reg1_reg, reg1_next : std_logic := '0';
	signal reg2_reg, reg2_next : std_logic := '0';
	signal output_reg, output_next : std_logic := '0';

begin

	mem : process (clk)
	begin
	
		if (clk'event and clk='1') then
			reg0_reg <= reg0_next;
			reg1_reg <= reg1_next;
			reg2_reg <= reg2_next;
			output_reg <= output_next;
		end if;
	
	end process;
	
	
	-- shift in and compare:
	reg0_next <= sig_input when (en_tick = '1') else reg0_reg;
	reg1_next <= reg0_reg when (en_tick = '1') else reg1_reg;
	reg2_next <= reg1_reg when (en_tick = '1') else reg2_reg;
	
	-- compare logic and setting
	output_next <= '1' when (reg0_reg='1' and reg1_reg='1' and reg2_reg = '1') else
						'0' when (reg0_reg='0' and reg1_reg='0' and reg2_reg = '0') else
						output_reg;
						
						
	sig_output <= output_reg;
	


end arch;

