----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:04:45 08/11/2009 
-- Design Name: 
-- Module Name:    Mos_State_2_Bin - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Mos_State_2_Bin is

    Port 	
			(
			--MS2B_I_clk 			: in  STD_LOGIC;
			--MS2B_I_reset	 	: in  STD_LOGIC;
			MS2B_I_Mos_state	: in 	std_logic_vector(3 downto 0);
			MS2B_O_Mos_bin		: out std_logic_vector(5 downto 0);
			MS2B_O_PWM			: out std_logic
			);
			
end Mos_State_2_Bin;

architecture arch of Mos_State_2_Bin is

signal input 	: std_logic_vector(3 downto 0);
signal output 	: std_logic_vector(5 downto 0);

begin

--Assignments

	input <= MS2B_I_Mos_state;
	MS2B_O_Mos_bin <= output;

	process(input)
	begin
		case input is
		
			-- State 0
			when "0000" =>
				-- no output
				output <= "000000";
				
			-- State 1
			when "0001" =>
				-- A1 and D4 and F6
				output <= "101001";
				
			-- State 2
			when "0010" =>
				-- A1 and D4
				output <= "001001";
				
			-- State 3
			when "0011" =>
				-- A1 and D4 and E5
				output <= "011001";
				
			-- State 4
			when "0100" =>
				-- D4 and E5
				output <= "011000";
				
			-- State 5
			when "0101" =>
				-- B2 and D4 and E5
				output <= "011010";
				
			-- State 6
			when "0110" =>
				-- B2 and E5
				output <= "010010";
				
			-- State 7
			when "0111" =>
				-- B2 and C3 and E5
				output <= "010110";
				
			-- State 8
			when "1000" =>
				-- B2 and C3
				output <= "000110";
				
			-- State 9
			when "1001" =>
				-- B2 and C3 and F6
				output <= "100110";
				
			-- State 10
			when "1010" =>
				-- C3 and F6
				output <= "100100";
				
			-- State 11
			when "1011" =>
				-- A1 and C3 and F6
				output <= "100101";
				
			-- State 12
			when "1100" =>
				-- A1 and F6
				output <= "100001";
				
			
			
			when others =>
				output <= "000000";
		
		end case;
	end process;
	
end arch;

